services:
  # --- SERVIÇO NGINX ---
  # Responsável por servir o frontend e fazer o proxy para a API.
  nginx:
    # Nossa arquitetura anterior, que construía o Nginx, era instável.
    # Agora, vamos usar uma imagem oficial e volumes, que é a arquitetura que
    # contorna a instabilidade do seu servidor.
    image: nginx:1.25-alpine
    container_name: agenda_nginx
    restart: unless-stopped
    ports:
      # Expomos a porta 8081, que o Apache irá usar para se conectar.
      - "8081:80"
    volumes:
      - ./frontend/dist:/usr/share/nginx/html
      - ./frontend/nginx.conf:/etc/nginx/conf.d/default.conf
    depends_on:
      - api
    networks:
      - agenda_network

  # --- SERVIÇO API ---
  api:
    build: ./backend
    container_name: agenda_api
    restart: unless-stopped
    # A API não precisa mais de 'ports', pois só o Nginx do Docker fala com ela.
    volumes:
      - ./backend:/app
    env_file: .env
    depends_on:
      db:
        condition: service_healthy
    networks:
      - agenda_network
    command: uvicorn app.main:app --host 0.0.0.0 --port 8000

  # --- SERVIÇO DB (sem alterações) ---
  db:
    image: postgres:15-alpine
    container_name: agenda_db_postgres
    restart: unless-stopped
    volumes:
      - postgres_data:/var/lib/postgresql/data/
    env_file: .env
    environment:
      POSTGRES_USER: ${POSTGRES_USER}
      POSTGRES_PASSWORD: ${POSTGRES_PASSWORD}
      POSTGRES_DB: ${POSTGRES_DB_NAME}
    healthcheck:
      test: ["CMD-SHELL", "pg_isready -U ${POSTGRES_USER} -d ${POSTGRES_DB_NAME}"]
      interval: 10s
      timeout: 5s
      retries: 5
    networks:
      - agenda_network

volumes:
  postgres_data:

networks:
  agenda_network:
    driver: bridge